<?php
class ControllerModuleWelcome extends Controller {
	private $error = array();

	public function index() {
    $this->load->type('tipocomum');
    $this->load->helper('ftr_geral');

    $language = $this->language->load('module/welcome');

    $this->data = array_merge($this->data, $language);

    $this->data['languageForJS'] = array(
      'module/welcome' => $language
    );

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/setting');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->model_setting_setting->editSetting('welcome', $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			$this->redirect($this->url->linkAnchor('extension/module', 'token=' . $this->session->data['token'], 'tab-info=' . $this->request->get['type'], 'SSL'));
		}

    $this->data['heading_title'] = $this->language->get('heading_title');

    $this->document->addTypesForJs(array(
      Type_Status::getTypeForJs(),
      Type_ModulePosition::getTypeForJs(),
    ));

    $this->document->addScript(array(
      'view/javascript/ckeditor/ckeditor.js',
      'admin/public/js/module/welcome.js',
    ));

    $this->data['ftr_geral'] = new ftr_geral();
    $this->data['Type_Status'] = $this->load->typeForTwig('Type_Status');

    // Language_id necessario para o CKEDITOR
    $this->data['language_id'] = 1;

		$this->data['text_enabled'] = $this->language->get('text_enabled');
		$this->data['text_disabled'] = $this->language->get('text_disabled');
		$this->data['text_content_top'] = $this->language->get('text_content_top');
		$this->data['text_content_bottom'] = $this->language->get('text_content_bottom');
		$this->data['text_column_left'] = $this->language->get('text_column_left');
		$this->data['text_column_right'] = $this->language->get('text_column_right');

		$this->data['entry_layout'] = $this->language->get('entry_layout');
		$this->data['entry_position'] = $this->language->get('entry_position');
		$this->data['entry_status'] = $this->language->get('entry_status');
		$this->data['entry_sort_order'] = $this->language->get('entry_sort_order');

		$this->data['button_save'] = $this->language->get('button_save');
		$this->data['button_cancel'] = $this->language->get('button_cancel');
		$this->data['button_add_module'] = $this->language->get('button_add_module');
		$this->data['button_remove'] = $this->language->get('button_remove');

		$this->data['tab_module'] = $this->language->get('tab_module');

 		if (isset($this->error['warning'])) {
			$this->data['error_warning'] = $this->error['warning'];
		} else {
			$this->data['error_warning'] = '';
		}

  		$this->data['breadcrumbs'] = array();

   		$this->data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('text_home'),
			'href'      => $this->url->link('common/home', 'token=' . $this->session->data['token'], 'SSL'),
      		'separator' => false
   		);

   		$this->data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('text_module'),
			'href'      => $this->url->linkAnchor('extension/module', 'token=' . $this->session->data['token'], 'tab-info=' . $this->request->get['type'], 'SSL'),
      		'separator' => ' :: '
   		);

   		$this->data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('heading_title'),
			'href'      => $this->url->link('module/welcome', 'token=' . $this->session->data['token'] . '&type=' . $this->request->get['type'], 'SSL'),
      		'separator' => ' :: '
   		);

		$this->data['action'] = $this->url->link('module/welcome', 'token=' . $this->session->data['token'] . '&type=' . $this->request->get['type'], 'SSL');

		$this->data['cancel'] = $this->url->linkAnchor('extension/module', 'token=' . $this->session->data['token'], 'tab-info=' . $this->request->get['type'], 'SSL');

		$this->data['token'] = $this->session->data['token'];

    $this->data['modules'] = array();


		if (isset($this->request->post['welcome_module'])) {
      $this->data['modules'] = $this->request->post['welcome_module'];
		} elseif ($this->config->get('welcome_module')) {
      $this->data['modules'] = $this->config->get('welcome_module');
    }

    if ($this->data['modules']) {
      $this->data['module_keys'] = max(array_keys($this->data['modules']));
    } else {
      $this->data['module_keys'] = 0;
    }


		$this->load->dmodel('design/layout');

    $this->data['layouts'] = $this->dmodel_design_layout->getLayouts();

    $this->data['positions'] = Type_ModulePosition::getEnumList();

		$this->load->model('localisation/language');

		$this->data['languages'] = $this->model_localisation_language->getLanguages();

		$this->children = array(
			'common/header',
			'common/footer'
		);

		$this->response->setOutput($this->render('module/welcome'));
	}

	protected function validate() {
		if (!$this->user->hasPermission('modify', 'module/welcome')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		if (!$this->error) {
			return true;
		} else {
			return false;
		}
	}
}
